const express = require('express');
const bodyParser = require('body-parser');
const routerFactory = require('./installationWizard')
const configurationManager = require('./configurationManager')
const expressLayouts = require('express-ejs-layouts');
const path = require('path');
//const vaultRouter = require('../routes/vault/vault')
//const flash = require('connect-flash');
//const session = require('express-session');

const app = express();

// view engine setup
app.set('views', path.join(__dirname, '../views'));
app.set('view engine', 'ejs');
app.use(expressLayouts);

// Express body parser
app.use(express.urlencoded({ extended: true }));

app.use(express.json());
/*
// --- ONLY NEEDED FOR VAULT ---
app.use(
  session({
    secret: process.env.SESSION_SECRET,
    resave: true,
    saveUninitialized: true
  })
);

// Connect flash
app.use(flash());

// catch 404 and forward to error handler
app.use(function (req, res, next) {
  res.locals.success_msg = req.flash('success_msg');
  res.locals.error_msg = req.flash('error_msg');
  res.locals.error = req.flash('error');
  res.locals.logs = req.flash('logs');
  next();
});
*/
app.use('/setup', routerFactory(configurationManager))

//app.use('/setup/vault', vaultRouter)

app.set('configurationManager', configurationManager)

app.get('/', (req, res) => {
  res.redirect('/setup/wizard?page=0')
})

module.exports = app